# coding: utf-8

"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from rockset.swagger_client.models.error_model_context import ErrorModelContext  # noqa: F401,E501


class ErrorModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'code': 'int',
        'message': 'str',
        'type': 'str',
        'context': 'ErrorModelContext'
    }

    attribute_map = {
        'code': 'code',
        'message': 'message',
        'type': 'type',
        'context': 'context'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """ErrorModel - a model defined in Swagger"""  # noqa: E501

        self._code = None
        self._message = None
        self._type = None
        self._context = None
        self.discriminator = None

        self.code = kwargs.pop('code', None)
        self.message = kwargs.pop('message', None)
        self.type = kwargs.pop('type', None)
        self.context = kwargs.pop('context', None)

    @property
    def code(self):
        """Gets the code of this ErrorModel.  # noqa: E501

        HTTP status code  # noqa: E501

        :return: The code of this ErrorModel.  # noqa: E501
        :rtype: int
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ErrorModel.

        HTTP status code  # noqa: E501

        :param code: The code of this ErrorModel.  # noqa: E501
        :type: int
        """

        self._code = code

    @property
    def message(self):
        """Gets the message of this ErrorModel.  # noqa: E501

        descriptive message about the error  # noqa: E501

        :return: The message of this ErrorModel.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ErrorModel.

        descriptive message about the error  # noqa: E501

        :param message: The message of this ErrorModel.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def type(self):
        """Gets the type of this ErrorModel.  # noqa: E501

        category of the error  # noqa: E501

        :return: The type of this ErrorModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ErrorModel.

        category of the error  # noqa: E501

        :param type: The type of this ErrorModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def context(self):
        """Gets the context of this ErrorModel.  # noqa: E501

        additional error information  # noqa: E501

        :return: The context of this ErrorModel.  # noqa: E501
        :rtype: ErrorModelContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this ErrorModel.

        additional error information  # noqa: E501

        :param context: The context of this ErrorModel.  # noqa: E501
        :type: ErrorModelContext
        """

        self._context = context

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ErrorModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

    def __getitem__(self, item):
        return getattr(self, item)

    def get(self, item):
        return getattr(self, item)

    def items(self):
        return self.to_dict().items()

    def __setitem__(self, item, value):
        return seattr(self, item, value)
